#include "chil_global.h"

void (*CHILFree) (void *) = CHILFreeDefault;
void* (*CHILCalloc) (size_t nelems, size_t elsize) = CHILCallocDefault;

void CHILFreeDefault (void *ptr) {
   free(ptr);
}

void *CHILCallocDefault (size_t nelems, size_t elsize) {
   void *buffer;
   if ((buffer = calloc(nelems, elsize)) == NULL) {
      CHILPrintf("Cannot allocate memory\n");
      exit(1);
   }
   return buffer;
}

void CHILSetCallocFunction(void* (*calloc_function) (size_t, size_t)) {
   CHILCalloc = calloc_function;
}

void CHILSetFreeFunction(void (*free_function) (void *)) {
   CHILFree = free_function;
}

